
<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta charset="utf-8" />
    <title>controller.brms_validation module &#8212; DataMAx 0.1 documentation</title>
    <link rel="stylesheet" href="_static/nature.css" type="text/css" />
    <link rel="stylesheet" href="_static/pygments.css" type="text/css" />
    <script type="text/javascript" id="documentation_options" data-url_root="./" src="_static/documentation_options.js"></script>
    <script type="text/javascript" src="_static/jquery.js"></script>
    <script type="text/javascript" src="_static/underscore.js"></script>
    <script type="text/javascript" src="_static/doctools.js"></script>
    <script type="text/javascript" src="_static/language_data.js"></script>
    <link rel="index" title="Index" href="genindex.html" />
    <link rel="search" title="Search" href="search.html" /> 
  </head><body>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="nav-item nav-item-0"><a href="index.html">DataMAx 0.1 documentation</a> &#187;</li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="module-controller.brms_validation">
<span id="controller-brms-validation-module"></span><h1>controller.brms_validation module<a class="headerlink" href="#module-controller.brms_validation" title="Permalink to this headline">¶</a></h1>
<p>Business Rule Management API for Validation.</p>
<div class="admonition seealso">
<p class="admonition-title">See also</p>
<p><a class="reference internal" href="controller.exchange.html#module-controller.exchange" title="controller.exchange"><code class="xref py py-func docutils literal notranslate"><span class="pre">exchange()</span></code></a> API Exchange module to carry out database operations.</p>
</div>
<p class="rubric">Notes</p>
<p>To allow construction of rules by the non-programmers.
A rule designer that gives a text area for a person to type in statements -
is really a programming environment, not a business user-focused tool.</p>
<dl class="function">
<dt id="controller.brms_validation.index">
<code class="sig-prename descclassname">controller.brms_validation.</code><code class="sig-name descname">index</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#controller.brms_validation.index" title="Permalink to this definition">¶</a></dt>
<dd><p>BRMS Engine for validation.</p>
</dd></dl>

<dl class="function">
<dt id="controller.brms_validation.create_validation">
<code class="sig-prename descclassname">controller.brms_validation.</code><code class="sig-name descname">create_validation</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#controller.brms_validation.create_validation" title="Permalink to this definition">¶</a></dt>
<dd><p>Create validation workflow for the BRMS.</p>
<p>Workflow is defined for a specific file adaptor. These file adaptors enable polling of metadata
(column names and their data type) from  in-application database.</p>
<p>Each validation workflow is a template of rules in the saved state.</p>
<dl class="field-list simple">
<dt class="field-odd">Returns</dt>
<dd class="field-odd"><p>a JSON object which has the <code class="docutils literal notranslate"><span class="pre">workflow_id</span></code> generated for the given request.</p>
</dd>
<dt class="field-even">Return type</dt>
<dd class="field-even"><p>dict</p>
</dd>
</dl>
<p class="rubric">Examples</p>
<div class="doctest highlight-default notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="kn">import</span> <span class="nn">requests</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">requests</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;http://localhost:5001/api/brms_validation/create_validation&#39;</span><span class="p">)</span>
<span class="go">{</span>
<span class="go">  &quot;workflow_id&quot;: &quot;46a0aea31273498a896b7761561c34de&quot;</span>
<span class="go">}</span>
</pre></div>
</div>
</dd></dl>

<dl class="function">
<dt id="controller.brms_validation.add_validation_meta">
<code class="sig-prename descclassname">controller.brms_validation.</code><code class="sig-name descname">add_validation_meta</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#controller.brms_validation.add_validation_meta" title="Permalink to this definition">¶</a></dt>
<dd><p>Add meta information to the workflow.</p>
<dl class="simple">
<dt>Meta information has the following attributes:</dt><dd><ul class="simple">
<li><p>name: name of the workflow</p></li>
<li><p>description: description of the workflow</p></li>
<li><p>status: can be DRAFT or PUBLISHED</p></li>
<li><p>workflow_id: string based unique Id</p></li>
</ul>
</dd>
</dl>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>validation_id</strong> (<em>str</em>) – unique Id of the validation</p></li>
<li><p><strong>name</strong> (<em>str</em>) – name of the workflow</p></li>
<li><p><strong>description</strong> (<em>str</em>) – description of the validation</p></li>
<li><p><strong>selected_datasets</strong> (<em>str</em>) – comma separated file adaptor names</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>a JSON object of the workflow generated for the given request.</p>
</dd>
<dt class="field-odd">Return type</dt>
<dd class="field-odd"><p>dict</p>
</dd>
</dl>
<p class="rubric">Examples</p>
<div class="doctest highlight-default notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="kn">import</span> <span class="nn">requests</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">requests</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;http://localhost:5001/api/brms_validation/add_validation_meta?name=hello&amp;description=some%20&#39;</span>
<span class="gp">... </span>             <span class="s1">&#39;desc&amp;selected_datasets=ds1&amp;validation_id=46a0aea31273498a896b7761561c34de&#39;</span><span class="p">)</span>
<span class="go">{</span>
<span class="go">  &quot;DATASETS&quot;: {</span>
<span class="go">    &quot;ds1&quot;: [</span>
<span class="go">      {</span>
<span class="go">        &quot;column_name&quot;: &quot;c1&quot;,</span>
<span class="go">        &quot;data_type&quot;: &quot;varchar&quot;</span>
<span class="go">      },</span>
<span class="go">      {</span>
<span class="go">        &quot;column_name&quot;: &quot;c2&quot;,</span>
<span class="go">        &quot;data_type&quot;: &quot;varchar&quot;</span>
<span class="go">      },</span>
<span class="go">      {</span>
<span class="go">        &quot;column_name&quot;: &quot;c3&quot;,</span>
<span class="go">        &quot;data_type&quot;: &quot;numeric&quot;</span>
<span class="go">      },</span>
<span class="go">      {</span>
<span class="go">        &quot;column_name&quot;: &quot;c4&quot;,</span>
<span class="go">        &quot;data_type&quot;: &quot;varchar&quot;</span>
<span class="go">      }</span>
<span class="go">    ]</span>
<span class="go">  },</span>
<span class="go">  &quot;META&quot;: {</span>
<span class="go">    &quot;description&quot;: &quot;some desc&quot;,</span>
<span class="go">    &quot;name&quot;: &quot;hello&quot;,</span>
<span class="go">    &quot;status&quot;: &quot;DRAFT&quot;,</span>
<span class="go">    &quot;workflow_id&quot;: &quot;46a0aea31273498a896b7761561c34de&quot;,</span>
<span class="go">    &quot;workspace_id&quot;: 1</span>
<span class="go">  },</span>
<span class="go">  &quot;PARAMETERS&quot;: {},</span>
<span class="go">  &quot;RULES&quot;: [],</span>
<span class="go">  &quot;SELECTED_DATASETS&quot;: {</span>
<span class="go">    &quot;ds1&quot;: [</span>
<span class="go">      {</span>
<span class="go">        &quot;column_name&quot;: &quot;c1&quot;,</span>
<span class="go">        &quot;data_type&quot;: &quot;varchar&quot;</span>
<span class="go">      },</span>
<span class="go">      {</span>
<span class="go">        &quot;column_name&quot;: &quot;c2&quot;,</span>
<span class="go">        &quot;data_type&quot;: &quot;varchar&quot;</span>
<span class="go">      },</span>
<span class="go">      {</span>
<span class="go">        &quot;column_name&quot;: &quot;c3&quot;,</span>
<span class="go">        &quot;data_type&quot;: &quot;numeric&quot;</span>
<span class="go">      },</span>
<span class="go">      {</span>
<span class="go">        &quot;column_name&quot;: &quot;c4&quot;,</span>
<span class="go">        &quot;data_type&quot;: &quot;varchar&quot;</span>
<span class="go">      }</span>
<span class="go">    ]</span>
<span class="go">  }</span>
<span class="go">}</span>
</pre></div>
</div>
</dd></dl>

<dl class="function">
<dt id="controller.brms_validation.add_rule">
<code class="sig-prename descclassname">controller.brms_validation.</code><code class="sig-name descname">add_rule</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#controller.brms_validation.add_rule" title="Permalink to this definition">¶</a></dt>
<dd><p>Add a rule to the validation workflow.</p>
<dl class="simple">
<dt>Each business rule in BRMS is a component. All components have the following schema:</dt><dd><ul class="simple">
<li><p>Rule: which carries the parameters required for prepared SQL query</p></li>
<li><p>Input: defines the metadata of the input dataset</p></li>
<li><p>Output: defines the metadata of the output dataset</p></li>
</ul>
</dd>
</dl>
<p>All components can be configured using text input.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>validation_id</strong> (<em>str</em>) – unique Id of the validation</p></li>
<li><p><strong>rule_name</strong> (<em>str</em>) – business name given to the rule</p></li>
<li><p><strong>user_input</strong> (<em>str</em>) – user text based on validation to be configured in the system.</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>a JSON object of the workflow generated for the given request.</p>
</dd>
<dt class="field-odd">Return type</dt>
<dd class="field-odd"><p>dict</p>
</dd>
</dl>
<p class="rubric">Examples</p>
<p>Add a rule without a parameter.</p>
<div class="doctest highlight-default notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="kn">import</span> <span class="nn">requests</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">requests</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;http://localhost:5001/api/brms_validation/add_rule?rule_name=first</span><span class="si">%20r</span><span class="s1">ule&#39;</span>
<span class="gp">... </span>             <span class="s1">&#39;&amp;user_input=data type of column c1 is integer&amp;validation_id=46a0aea31273498a896b7761561c34de&#39;</span>
<span class="go">{</span>
<span class="go">  &quot;DATASETS&quot;: { ... },</span>
<span class="go">  &quot;META&quot;: {</span>
<span class="go">    &quot;description&quot;: &quot;some desc&quot;,</span>
<span class="go">    &quot;name&quot;: &quot;hello&quot;,</span>
<span class="go">    &quot;status&quot;: &quot;DRAFT&quot;,</span>
<span class="go">    &quot;workflow_id&quot;: &quot;46a0aea31273498a896b7761561c34de&quot;,</span>
<span class="go">    &quot;workspace_id&quot;: 1</span>
<span class="go">  },</span>
<span class="go">  &quot;PARAMETERS&quot;: {},</span>
<span class="go">  &quot;RULES&quot;: [</span>
<span class="go">    {</span>
<span class="go">        &#39;rule_id&#39;: &quot;9a8a8b2d3c504e99859f6de291b90fcc&quot;,</span>
<span class="go">        &#39;rule_name&#39;: &#39;data_type_integer&#39;,</span>
<span class="go">        &#39;column&#39;: &#39;c1&#39;,</span>
<span class="go">        &#39;input&#39;: &#39;ds1&#39;,</span>
<span class="go">        &#39;output&#39;: &#39;ds1&#39;,</span>
<span class="go">        &#39;parameters&#39;: [],</span>
<span class="go">        &#39;query&#39;: &quot;update {schema}.{ds1} set dmx_message = concat(dmx_message, &#39;c1 value is not integer;&#39;) &quot;</span>
<span class="go">                 &quot;where c1 !~ &#39;^(-)?[0-9]+$&#39;&quot;,</span>
<span class="go">    }</span>
<span class="go">  ],</span>
<span class="go">  &quot;SELECTED_DATASETS&quot;: { ... }</span>
<span class="go">}</span>
</pre></div>
</div>
</dd></dl>

<dl class="function">
<dt id="controller.brms_validation.update_rule">
<code class="sig-prename descclassname">controller.brms_validation.</code><code class="sig-name descname">update_rule</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#controller.brms_validation.update_rule" title="Permalink to this definition">¶</a></dt>
<dd><p>Update a validation rule in the workflow.</p>
<dl class="simple">
<dt>Each validation rule in BRMS for validation is a component. All components have the following schema:</dt><dd><ul class="simple">
<li><p>Rule: which carries the parameters required for prepared SQL query</p></li>
<li><p>Input: defines the metadata of the input dataset</p></li>
<li><p>Output: defines the metadata of the output dataset</p></li>
</ul>
</dd>
</dl>
<p>All components can be configured using text input.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>validation_id</strong> (<em>str</em>) – unique Id of the validation</p></li>
<li><p><strong>rule_name</strong> (<em>str</em>) – business name given to the rule</p></li>
<li><p><strong>user_input</strong> (<em>str</em>) – user text based on components being configured in the system.</p></li>
<li><p><strong>rule_id</strong> (<em>str</em>) – rule Id used to recognize the rule which has to be updated.</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>a JSON object of the workflow generated for the given request.</p>
</dd>
<dt class="field-odd">Return type</dt>
<dd class="field-odd"><p>dict</p>
</dd>
</dl>
<p class="rubric">Examples</p>
<p>Add a rule without a parameter.</p>
<div class="doctest highlight-default notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="kn">import</span> <span class="nn">requests</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">requests</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;http://localhost:5001/api/brms_validation/update_rule?rule_name=first</span><span class="si">%20r</span><span class="s1">ule&#39;</span>
<span class="gp">... </span>             <span class="s1">&#39;&amp;user_input=data type of column c1 is float&amp;rule_id=9a8a8b2d3c504e99859f6de291b90fcc&#39;</span>
<span class="gp">... </span>             <span class="s1">&#39;&amp;validation_id=46a0aea31273498a896b7761561c34de&#39;</span><span class="p">)</span>
<span class="go">{</span>
<span class="go">  &quot;DATASETS&quot;: { ... },</span>
<span class="go">  &quot;META&quot;: {</span>
<span class="go">    &quot;description&quot;: &quot;some desc&quot;,</span>
<span class="go">    &quot;name&quot;: &quot;hello&quot;,</span>
<span class="go">    &quot;status&quot;: &quot;DRAFT&quot;,</span>
<span class="go">    &quot;workflow_id&quot;: &quot;46a0aea31273498a896b7761561c34de&quot;,</span>
<span class="go">    &quot;workspace_id&quot;: 1</span>
<span class="go">  },</span>
<span class="go">  &quot;PARAMETERS&quot;: { ... },</span>
<span class="go">  &quot;RULES&quot;: [</span>
<span class="go">    {</span>
<span class="go">        &#39;rule_id&#39;: &quot;9a8a8b2d3c504e99859f6de291b90fcc&quot;,</span>
<span class="go">        &#39;rule_name&#39;: &#39;data_type_float&#39;,</span>
<span class="go">        &#39;column&#39;: &#39;c1&#39;,</span>
<span class="go">        &#39;input&#39;: &#39;ds1&#39;,</span>
<span class="go">        &#39;output&#39;: &#39;ds1&#39;,</span>
<span class="go">        &#39;parameters&#39;: [],</span>
<span class="go">        &#39;query&#39;: &quot;update {schema}.{ds1} set dmx_message = concat(dmx_message, &#39;c1 value is not float;&#39;) &quot;</span>
<span class="go">                 &quot;where c1 !~ &#39;^[0-9]*.?[0-9]*$&#39;&quot;,</span>
<span class="go">    }</span>
<span class="go">  ],</span>
<span class="go">  &quot;SELECTED_DATASETS&quot;: { ... }</span>
<span class="go">}</span>
</pre></div>
</div>
</dd></dl>

<dl class="function">
<dt id="controller.brms_validation.delete_rule">
<code class="sig-prename descclassname">controller.brms_validation.</code><code class="sig-name descname">delete_rule</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#controller.brms_validation.delete_rule" title="Permalink to this definition">¶</a></dt>
<dd><p>Delete a validation rule within the workflow.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>validation_id</strong> (<em>str</em>) – unique Id of the validation</p></li>
<li><p><strong>rule_id</strong> (<em>str</em>) – rule Id used to recognize the rule which has to be updated.</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>a JSON object of the workflow generated for the given request.</p>
</dd>
<dt class="field-odd">Return type</dt>
<dd class="field-odd"><p>dict</p>
</dd>
</dl>
<p class="rubric">Examples</p>
<div class="doctest highlight-default notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="kn">import</span> <span class="nn">requests</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">requests</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;http://localhost:5001/api/brms_validation/delete_rule?&#39;</span>
<span class="gp">... </span>             <span class="s1">&#39;rule_id=9a8a8b2d3c504e99859f6de291b90fcc&#39;</span>
<span class="gp">... </span>             <span class="s1">&#39;&amp;validation_id=46a0aea31273498a896b7761561c34de&#39;</span><span class="p">)</span>
<span class="go">{</span>
<span class="go">  &quot;DATASETS&quot;: { ... },</span>
<span class="go">  &quot;META&quot;: {</span>
<span class="go">    &quot;description&quot;: &quot;some desc&quot;,</span>
<span class="go">    &quot;name&quot;: &quot;hello&quot;,</span>
<span class="go">    &quot;status&quot;: &quot;DRAFT&quot;,</span>
<span class="go">    &quot;workflow_id&quot;: &quot;46a0aea31273498a896b7761561c34de&quot;,</span>
<span class="go">    &quot;workspace_id&quot;: 1</span>
<span class="go">  },</span>
<span class="go">  &quot;PARAMETERS&quot;: { ... },</span>
<span class="go">  &quot;RULES&quot;: [</span>
<span class="go">  ],</span>
<span class="go">  &quot;SELECTED_DATASETS&quot;: { ... }</span>
<span class="go">}</span>
</pre></div>
</div>
</dd></dl>

<dl class="function">
<dt id="controller.brms_validation.add_parameter_definition">
<code class="sig-prename descclassname">controller.brms_validation.</code><code class="sig-name descname">add_parameter_definition</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#controller.brms_validation.add_parameter_definition" title="Permalink to this definition">¶</a></dt>
<dd><p>Add parameter definition in the workflow.</p>
<p>Parameters can be configured within rule composer in which the user has the option to
select one of the following:</p>
<blockquote>
<div><ul class="simple">
<li><p>Picklist - dedicated input like Boolean values</p></li>
<li><p>Freehand text with alphanumeric or numeric constraint</p></li>
</ul>
</div></blockquote>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>validation_id</strong> (<em>str</em>) – unique Id of the validation.</p></li>
<li><p><strong>parameter_name</strong> (<em>str</em>) – name given to the parameter with $ sign.</p></li>
<li><p><strong>help_text</strong> (<em>str</em>) – business specific help text to be displayed in scenario screen.</p></li>
<li><p><strong>description</strong> (<em>str</em>) – describe the parameter being configured by the user.</p></li>
<li><p><strong>config_type</strong> (<em>str</em>) – picklist, column, numeric or text.</p></li>
<li><p><strong>config_value</strong> (<em>str</em>) – will vary based on the config_type
* picklist - string with comma-separated options
* numeric - None
* text - None</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>a JSON object of the workflow generated for the given request.</p>
</dd>
<dt class="field-odd">Return type</dt>
<dd class="field-odd"><p>dict</p>
</dd>
</dl>
<p class="rubric">Examples</p>
<div class="doctest highlight-default notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="kn">import</span> <span class="nn">requests</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">requests</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;http://localhost:5001/api/brms_validation/add_parameter_definition?parameter_name=$threshold&#39;</span>
<span class="gp">... </span>             <span class="s1">&#39;&amp;config_type=numeric&amp;config_value=&amp;validation_id=46a0aea31273498a896b7761561c34de&#39;</span>
<span class="gp">... </span>             <span class="s1">&#39;&amp;help_text=some%20threshold%20numeric%20value&amp;description=describe%20the%20threshold&#39;</span><span class="p">)</span>
<span class="go">{</span>
<span class="go">  &quot;DATASETS&quot;: {... },</span>
<span class="go">  &quot;META&quot;: {</span>
<span class="go">    &quot;description&quot;: &quot;some desc&quot;,</span>
<span class="go">    &quot;name&quot;: &quot;hello&quot;,</span>
<span class="go">    &quot;status&quot;: &quot;DRAFT&quot;,</span>
<span class="go">    &quot;workflow_id&quot;: &quot;46a0aea31273498a896b7761561c34de&quot;,</span>
<span class="go">    &quot;workspace_id&quot;: 1</span>
<span class="go">  },</span>
<span class="go">  &quot;PARAMETERS&quot;: {</span>
<span class="go">    &quot;$threshold&quot;: {</span>
<span class="go">      &quot;config_type&quot;: &quot;numeric&quot;,</span>
<span class="go">      &quot;config_value&quot;: &quot;&quot;,</span>
<span class="go">      &quot;description&quot;: &quot;describe the threshold&quot;,</span>
<span class="go">      &quot;help_text&quot;: &quot;some threshold numeric value&quot;,</span>
<span class="go">      &quot;name&quot;: &quot;$threshold&quot;</span>
<span class="go">    }</span>
<span class="go">  },</span>
<span class="go">  &quot;RULES&quot;: [</span>
<span class="go">    ...</span>
<span class="go">  ],</span>
<span class="go">  &quot;SELECTED_DATASETS&quot;: { ... }</span>
<span class="go">  }</span>
<span class="go">}</span>
</pre></div>
</div>
</dd></dl>

<dl class="function">
<dt id="controller.brms_validation.get_validation">
<code class="sig-prename descclassname">controller.brms_validation.</code><code class="sig-name descname">get_validation</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#controller.brms_validation.get_validation" title="Permalink to this definition">¶</a></dt>
<dd><p>Get a workflow as JSON.</p>
<p>Structure of JSON:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="p">{</span><span class="s2">&quot;DATASETS&quot;</span><span class="p">:</span> <span class="p">{},</span> <span class="s2">&quot;META&quot;</span><span class="p">:</span> <span class="p">{},</span> <span class="s2">&quot;SELECTED_DATASETS&quot;</span><span class="p">:</span> <span class="p">{},</span> <span class="s2">&quot;RULES&quot;</span><span class="p">:</span> <span class="p">[],</span> <span class="s2">&quot;PARAMETERS&quot;</span><span class="p">:</span> <span class="p">{}}</span>
</pre></div>
</div>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>validation_id</strong> (<em>str</em>) – Unique validation id used to identify the workflow.</p>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>a JSON object which has the data of the workflow.</p>
</dd>
<dt class="field-odd">Return type</dt>
<dd class="field-odd"><p>dict</p>
</dd>
</dl>
<p class="rubric">Examples</p>
<div class="doctest highlight-default notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="kn">import</span> <span class="nn">requests</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">requests</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;http://localhost:5001/api/brms_validation/get_validation?&#39;</span>
<span class="gp">... </span>             <span class="s1">&#39;validation_id=46a0aea31273498a896b7761561c34de&#39;</span><span class="p">)</span>
<span class="go">{</span>
<span class="go">  &quot;DATASETS&quot;: { ... },</span>
<span class="go">  &quot;META&quot;: {</span>
<span class="go">    &quot;description&quot;: &quot;&quot;,</span>
<span class="go">    &quot;name&quot;: &quot;&quot;,</span>
<span class="go">    &quot;status&quot;: &quot;DRAFT&quot;,</span>
<span class="go">    &quot;workflow_id&quot;: &quot;46a0aea31273498a896b7761561c34de&quot;,</span>
<span class="go">    &quot;workspace_id&quot;: 1</span>
<span class="go">  },</span>
<span class="go">  &quot;PARAMETERS&quot;: { ... },</span>
<span class="go">  &quot;RULES&quot;: [ ... ],</span>
<span class="go">  &quot;SELECTED_DATASETS&quot;: { ... }</span>
<span class="go">}</span>
</pre></div>
</div>
</dd></dl>

<dl class="function">
<dt id="controller.brms_validation.save_validation">
<code class="sig-prename descclassname">controller.brms_validation.</code><code class="sig-name descname">save_validation</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#controller.brms_validation.save_validation" title="Permalink to this definition">¶</a></dt>
<dd><p>Save BRMS workflow.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>validation_id</strong> (<em>str</em>) – Unique workflow id used to identify the workflow.</p>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>a JSON object which has the message that the workflow has been saved.</p>
</dd>
<dt class="field-odd">Return type</dt>
<dd class="field-odd"><p>dict</p>
</dd>
</dl>
<p class="rubric">Examples</p>
<div class="doctest highlight-default notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="kn">import</span> <span class="nn">requests</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">requests</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;http://localhost:5001/api/brms_validation/save_validation?&#39;</span>
<span class="gp">... </span>             <span class="s1">&#39;validation_id=46a0aea31273498a896b7761561c34de&#39;</span><span class="p">)</span>
<span class="go">{</span>
<span class="go">  &quot;message&quot; : &quot;Saved successfully&quot;</span>
<span class="go">}</span>
</pre></div>
</div>
</dd></dl>

<dl class="function">
<dt id="controller.brms_validation.publish_validation">
<code class="sig-prename descclassname">controller.brms_validation.</code><code class="sig-name descname">publish_validation</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#controller.brms_validation.publish_validation" title="Permalink to this definition">¶</a></dt>
<dd><p>Publish the BRMS Validation workflow.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>validation_id</strong> (<em>str</em>) – Unique validation id used to identify the workflow.</p>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>a JSON object which has the message that the workflow has been saved.</p>
</dd>
<dt class="field-odd">Return type</dt>
<dd class="field-odd"><p>dict</p>
</dd>
</dl>
<p class="rubric">Examples</p>
<div class="doctest highlight-default notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="kn">import</span> <span class="nn">requests</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">requests</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;http://localhost:5001/api/brms_validation/publish_validation?&#39;</span>
<span class="gp">... </span>             <span class="s1">&#39;validation_id=46a0aea31273498a896b7761561c34de&#39;</span><span class="p">)</span>
<span class="go">{</span>
<span class="go">  &quot;DATASETS&quot;: { ... },</span>
<span class="go">  &quot;META&quot;: {</span>
<span class="go">    &quot;description&quot;: &quot;&quot;,</span>
<span class="go">    &quot;name&quot;: &quot;&quot;,</span>
<span class="go">    &quot;status&quot;: &quot;PUBLISHED&quot;,</span>
<span class="go">    &quot;workflow_id&quot;: &quot;46a0aea31273498a896b7761561c34de&quot;,</span>
<span class="go">    &quot;workspace_id&quot;: 1</span>
<span class="go">  },</span>
<span class="go">  &quot;PARAMETERS&quot;: { ... },</span>
<span class="go">  &quot;RULES&quot;: [ ... ],</span>
<span class="go">  &quot;SELECTED_DATASETS&quot;: { ... }</span>
<span class="go">}</span>
</pre></div>
</div>
</dd></dl>

<dl class="function">
<dt id="controller.brms_validation.edit_validation">
<code class="sig-prename descclassname">controller.brms_validation.</code><code class="sig-name descname">edit_validation</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#controller.brms_validation.edit_validation" title="Permalink to this definition">¶</a></dt>
<dd><p>Edit the BRMS Validation workflow.</p>
<p>An API which raises BRMS based exception when requested with published workflow id.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>validation_id</strong> (<em>str</em>) – Unique validation id used to identify the workflow.</p>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>a JSON object which has the message that the workflow has been saved.</p>
</dd>
<dt class="field-odd">Return type</dt>
<dd class="field-odd"><p>dict</p>
</dd>
</dl>
<p class="rubric">Examples</p>
<div class="doctest highlight-default notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="kn">import</span> <span class="nn">requests</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">requests</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;http://localhost:5001/api/brms_validation/edit_validation?&#39;</span>
<span class="gp">... </span>             <span class="s1">&#39;validation_id=46a0aea31273498a896b7761561c34de&#39;</span><span class="p">)</span>
<span class="go">{</span>
<span class="go">  &quot;DATASETS&quot;: { ... },</span>
<span class="go">  &quot;META&quot;: {</span>
<span class="go">    &quot;description&quot;: &quot;&quot;,</span>
<span class="go">    &quot;name&quot;: &quot;&quot;,</span>
<span class="go">    &quot;status&quot;: &quot;DRAFT&quot;,</span>
<span class="go">    &quot;workflow_id&quot;: &quot;46a0aea31273498a896b7761561c34de&quot;,</span>
<span class="go">    &quot;workspace_id&quot;: 1</span>
<span class="go">  },</span>
<span class="go">  &quot;PARAMETERS&quot;: { ... },</span>
<span class="go">  &quot;RULES&quot;: [ ... ],</span>
<span class="go">  &quot;SELECTED_DATASETS&quot;: { ... }</span>
<span class="go">}</span>
</pre></div>
</div>
</dd></dl>

<dl class="function">
<dt id="controller.brms_validation.copy_validation">
<code class="sig-prename descclassname">controller.brms_validation.</code><code class="sig-name descname">copy_validation</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#controller.brms_validation.copy_validation" title="Permalink to this definition">¶</a></dt>
<dd><p>Copy the BRMS Validation workflow.</p>
<p>An API which creates a new workflow in DRAFT state using the copy of the workflow
of the id with which it has been requested.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>validation_id</strong> (<em>str</em>) – Unique validation id used to identify the workflow.</p>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>a JSON object which has the message that the workflow has been saved.</p>
</dd>
<dt class="field-odd">Return type</dt>
<dd class="field-odd"><p>dict</p>
</dd>
</dl>
<p class="rubric">Examples</p>
<div class="doctest highlight-default notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="kn">import</span> <span class="nn">requests</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">requests</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;http://localhost:5001/api/brms_validation/copy_validation?&#39;</span>
<span class="gp">... </span>             <span class="s1">&#39;validation_id=46a0aea31273498a896b7761561c34de&#39;</span><span class="p">)</span>
<span class="go">{</span>
<span class="go">  &quot;DATASETS&quot;: { ... },</span>
<span class="go">  &quot;META&quot;: {</span>
<span class="go">    &quot;description&quot;: &quot;&quot;,</span>
<span class="go">    &quot;name&quot;: &quot;&quot;,</span>
<span class="go">    &quot;status&quot;: &quot;DRAFT&quot;,</span>
<span class="go">    &quot;workflow_id&quot;: &quot;72a0aea31273498a896b7761561c34de&quot;,</span>
<span class="go">    &quot;workspace_id&quot;: 1</span>
<span class="go">  },</span>
<span class="go">  &quot;PARAMETERS&quot;: { ... },</span>
<span class="go">  &quot;RULES&quot;: [ ... ],</span>
<span class="go">  &quot;SELECTED_DATASETS&quot;: { ... }</span>
<span class="go">}</span>
</pre></div>
</div>
</dd></dl>

<dl class="function">
<dt id="controller.brms_validation.execute_validation">
<code class="sig-prename descclassname">controller.brms_validation.</code><code class="sig-name descname">execute_validation</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#controller.brms_validation.execute_validation" title="Permalink to this definition">¶</a></dt>
<dd><p>Execute the ACTIVE scenario of validation.</p>
<dl class="simple">
<dt>Assumption:</dt><dd><p>Adaptor name should not be exactly same as actual table name.</p>
</dd>
</dl>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>scenario_id</strong> (<em>str</em>) – unique scenario id to identify the scenario to be executed.</p></li>
<li><p><strong>validation_id</strong> (<em>str</em>) – unique workflow id to identify the workflow.</p></li>
<li><p><strong>output_schema</strong> (<em>str</em>) – [OPTIONAL] output tables are created in the schema - brms_output</p></li>
<li><p><strong>execution_schema</strong> (<em>str</em>) – [OPTIONAL] intermediate tables are created in the schema - brms_instance</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>A JSON object with exact queries and output table names for reference.</p>
</dd>
<dt class="field-odd">Return type</dt>
<dd class="field-odd"><p>dict</p>
</dd>
</dl>
<div class="admonition seealso">
<p class="admonition-title">See also</p>
<p><a class="reference internal" href="controller.brms.html#controller.brms.publish_workflow" title="controller.brms.publish_workflow"><code class="xref py py-func docutils literal notranslate"><span class="pre">publish_workflow()</span></code></a> Change the state of the validation to published.</p>
</div>
<dl class="field-list simple">
<dt class="field-odd">Raises</dt>
<dd class="field-odd"><ul class="simple">
<li><p><a class="reference internal" href="utils.exceptions.html#utils.exceptions.BRMSDraftWorkflowExecuted" title="utils.exceptions.BRMSDraftWorkflowExecuted"><strong>BRMSDraftWorkflowExecuted</strong></a> – This exception is raised when a draft version of the workflow</p></li>
<li><p><strong>is triggered to execute.</strong> – </p></li>
</ul>
</dd>
</dl>
<p class="rubric">Examples</p>
<div class="doctest highlight-default notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="kn">import</span> <span class="nn">requests</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">requests</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;http://localhost:5001/api/brms_validation/execute_validation?&#39;</span>
<span class="gp">... </span>             <span class="s1">&#39;validation_id=46a0aea31273498a896b7761561c34de&#39;</span>
<span class="gp">... </span>             <span class="s1">&#39;&amp;scenario_id=3&#39;</span><span class="p">)</span>
<span class="go">{</span>
<span class="go">  &#39;META&#39;: {</span>
<span class="go">    &#39;scenario_id&#39;: &#39;3&#39;,</span>
<span class="go">    &#39;workflow_id&#39;: &#39;4f21746f4ca148d6b9e2626e4c0e7ef7&#39;,</span>
<span class="go">    &#39;status&#39;: &#39;passed&#39;</span>
<span class="go">  },</span>
<span class="go">  &#39;QUERY&#39;: [</span>
<span class="go">    ...</span>
<span class="go">  ],</span>
<span class="go">  &#39;OUTPUT&#39;: {</span>
<span class="go">      &#39;ds1&#39;: &#39;...&#39;,</span>
<span class="go">      &#39;error_ds1&#39;: &#39;...&#39;,</span>
<span class="go">      &#39;success_ds1&#39;: &#39;...&#39;,</span>
<span class="go">    },</span>
<span class="go">  &#39;INVALID_META&#39;: {</span>
<span class="go">    &#39;ds1&#39;: {</span>
<span class="go">      &#39;invalid_count&#39;: 750,</span>
<span class="go">      &#39;total_count&#39;: 4000</span>
<span class="go">    }</span>
<span class="go">  }</span>
<span class="go">}</span>
</pre></div>
</div>
</dd></dl>

</div>


          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <div role="note" aria-label="source link">
    <h3>This Page</h3>
    <ul class="this-page-menu">
      <li><a href="_sources/controller.brms_validation.rst.txt"
            rel="nofollow">Show Source</a></li>
    </ul>
   </div>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" />
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="nav-item nav-item-0"><a href="index.html">DataMAx 0.1 documentation</a> &#187;</li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2019, AxtriaOne.
      Created using <a href="http://sphinx-doc.org/">Sphinx</a> 2.3.1.
    </div>
  </body>
</html>